# PluginCodec_MediaFormat< NAME > Class Template Reference

`#include <opalplugin.hpp>`

Inheritance diagram for PluginCodec_MediaFormat< NAME >:

[legend]
Collaboration diagram for PluginCodec_MediaFormat< NAME >:
[legend]

## Public Types

typedef PluginCodec_Option const *const * | OptionsTable
typedef PluginCodec_OptionMap | OptionMap

## Public Member Functions

virtual | ~PluginCodec_MediaFormat ()
__inline const char * | GetFormatName () const
__inline const char * | GetPayloadName () const
__inline unsigned char | GetPayloadType () const
__inline const char * | GetDescription () const
__inline unsigned | GetMaxBandwidth () const
__inline unsigned char | GetH323CapabilityType () const
__inline const void * | GetH323CapabilityData () const
__inline unsigned | GetFlags () const
__inline const void * | GetOptionsTable () const
virtual bool | IsValidForProtocol (const char *)
| Determine if codec is valid for the specified protocol.
bool | AdjustOptions (void *parm, unsigned *parmLen, bool(PluginCodec_MediaFormat::*adjuster)(OptionMap &original, OptionMap &changed))
| Utility function to adjust option strings, used by ToNormalised()/ToCustomised().
virtual bool | ToNormalised (OptionMap &, OptionMap &)
| Adjust normalised options calculated from codec specific options.
virtual bool | ToCustomised (OptionMap &, OptionMap &)
virtual void | AdjustForVersion (unsigned version, const PluginCodec_Definition *)

## Static Public Member Functions

static void | AdjustAllForVersion (unsigned version, const PluginCodec_Definition *definitions, size_t size)

## Protected Member Functions

| PluginCodec_MediaFormat (const char *formatName, const char *payloadName, const char *description, unsigned maxBandwidth, OptionsTable options)

## Protected Attributes

const char * | m_formatName
const char * | m_payloadName
unsigned | m_payloadType
const char * | m_description
unsigned | m_maxBandwidth
unsigned | m_h323CapabilityType
const void * | m_h323CapabilityData
unsigned | m_flags
OptionsTable | m_options

### template<typename NAME>
class PluginCodec_MediaFormat< NAME >

## Member Typedef Documentation

template<typename NAME>

typedef PluginCodec_OptionMap PluginCodec_MediaFormat< NAME >::OptionMap

template<typename NAME>

typedef struct PluginCodec_Option const* const* PluginCodec_MediaFormat< NAME >::OptionsTable

Reimplemented in PluginCodec_AudioFormat< NAME >, and PluginCodec_VideoFormat< NAME >.

## Constructor & Destructor Documentation

template<typename NAME>

PluginCodec_MediaFormat< NAME >::PluginCodec_MediaFormat | ( | const char * | formatName,
|  | const char * | payloadName,
|  | const char * | description,
|  | unsigned | maxBandwidth,
|  | OptionsTable | options |
| ) |  |  | `[inline, protected]`

template<typename NAME>

virtual PluginCodec_MediaFormat< NAME >::~PluginCodec_MediaFormat | ( |  | ) | `[inline, virtual]`

## Member Function Documentation

template<typename NAME>

static void PluginCodec_MediaFormat< NAME >::AdjustAllForVersion | ( | unsigned | version,
|  | const PluginCodec_Definition * | definitions,
|  | size_t | size |
| ) |  |  | `[inline, static]`

template<typename NAME>

virtual void PluginCodec_MediaFormat< NAME >::AdjustForVersion | ( | unsigned | version,
|  | const PluginCodec_Definition * |  |
| ) |  |  | `[inline, virtual]`

template<typename NAME>

bool PluginCodec_MediaFormat< NAME >::AdjustOptions | ( | void * | parm,
|  | unsigned * | parmLen,
|  | bool(PluginCodec_MediaFormat< NAME >::*)(OptionMap &original, OptionMap &changed) | adjuster |
| ) |  |  | `[inline]`

Utility function to adjust option strings, used by ToNormalised()/ToCustomised().

template<typename NAME>

__inline const char* PluginCodec_MediaFormat< NAME >::GetDescription | ( |  | ) | const`[inline]`

template<typename NAME>

__inline unsigned PluginCodec_MediaFormat< NAME >::GetFlags | ( |  | ) | const`[inline]`

template<typename NAME>

__inline const char* PluginCodec_MediaFormat< NAME >::GetFormatName | ( |  | ) | const`[inline]`

template<typename NAME>

__inline const void* PluginCodec_MediaFormat< NAME >::GetH323CapabilityData | ( |  | ) | const`[inline]`

template<typename NAME>

__inline unsigned char PluginCodec_MediaFormat< NAME >::GetH323CapabilityType | ( |  | ) | const`[inline]`

template<typename NAME>

__inline unsigned PluginCodec_MediaFormat< NAME >::GetMaxBandwidth | ( |  | ) | const`[inline]`

template<typename NAME>

__inline const void* PluginCodec_MediaFormat< NAME >::GetOptionsTable | ( |  | ) | const`[inline]`

template<typename NAME>

__inline const char* PluginCodec_MediaFormat< NAME >::GetPayloadName | ( |  | ) | const`[inline]`

template<typename NAME>

__inline unsigned char PluginCodec_MediaFormat< NAME >::GetPayloadType | ( |  | ) | const`[inline]`

template<typename NAME>

virtual bool PluginCodec_MediaFormat< NAME >::IsValidForProtocol | ( | const char * |  | ) | `[inline, virtual]`

Determine if codec is valid for the specified protocol.

template<typename NAME>

virtual bool PluginCodec_MediaFormat< NAME >::ToCustomised | ( | OptionMap & | ,
|  | OptionMap & |  |
| ) |  |  | `[inline, virtual]`

template<typename NAME>

virtual bool PluginCodec_MediaFormat< NAME >::ToNormalised | ( | OptionMap & | ,
|  | OptionMap & |  |
| ) |  |  | `[inline, virtual]`

Adjust normalised options calculated from codec specific options.

## Field Documentation

template<typename NAME>

const char* PluginCodec_MediaFormat< NAME >::m_description `[protected]`

template<typename NAME>

unsigned PluginCodec_MediaFormat< NAME >::m_flags `[protected]`

template<typename NAME>

const char* PluginCodec_MediaFormat< NAME >::m_formatName `[protected]`

template<typename NAME>

const void* PluginCodec_MediaFormat< NAME >::m_h323CapabilityData `[protected]`

template<typename NAME>

unsigned PluginCodec_MediaFormat< NAME >::m_h323CapabilityType `[protected]`

template<typename NAME>

unsigned PluginCodec_MediaFormat< NAME >::m_maxBandwidth `[protected]`

template<typename NAME>

OptionsTable PluginCodec_MediaFormat< NAME >::m_options `[protected]`

template<typename NAME>

const char* PluginCodec_MediaFormat< NAME >::m_payloadName `[protected]`

template<typename NAME>

unsigned PluginCodec_MediaFormat< NAME >::m_payloadType `[protected]`

The documentation for this class was generated from the following file:

- opalplugin.hpp